"""
    Ledger API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0
    Generated by: https://openapi-generator.tech
"""


import unittest

import ledgerclient
from ledgerclient.api.accounts_api import AccountsApi  # noqa: E501
from ledgerclient.api.transactions_api import TransactionsApi
from ledgerclient.model.metadata import Metadata
from ledgerclient.model.posting import Posting
from ledgerclient.model.transaction_data import TransactionData
from test.test_base import TestBase


class TestAccountsApi(TestBase):
    """AccountsApi unit test stubs"""

    def setUp(self):
        super().setUp()
        self.transactionApi = TransactionsApi(self.client)  # noqa: E501
        self.accountApi = AccountsApi(self.client)
        self.transactionApi.create_transaction(self.ledger, TransactionData([
            Posting(100, 'USD', 'player1', 'world'),
        ]))

    def test_add_metadata_to_account(self):
        """Test case for add_metadata_to_account

        Add metadata to account  # noqa: E501
        """
        self.accountApi.add_metadata_to_account(self.ledger, "world1", metadata=Metadata(foo='bar'))
        account = self.accountApi.get_account(self.ledger, "world1")
        self.assertEqual('bar', account.data.metadata['foo'])

    def test_get_account(self):
        """Test case for get_account

        Get account by address  # noqa: E501
        """
        self.accountApi.get_account(self.ledger, "player1")

    def test_list_accounts(self):
        """Test case for list_accounts

        List all accounts  # noqa: E501
        """
        accounts = self.accountApi.list_accounts(self.ledger)
        self.assertEqual(2, len(accounts.cursor.data))


if __name__ == '__main__':
    unittest.main()
